org.h2.value

## Class ValueTimestampTimeZone

- java.lang.Object
- - org.h2.value.VersionedValue
  - - org.h2.value.Value
    - - org.h2.value.ValueTimestampTimeZone

    public class ValueTimestampTimeZone
    extends Value

Implementation of the TIMESTAMP WITH TIME ZONE data type.

See Also:
  ISO 8601 Time zone designators

### Field Summary

Fields
`static int` `DEFAULT_PRECISION` The default precision and display size of the textual representation of a timestamp.
`static int` `MAXIMUM_PRECISION` The maximum precision and display size of the textual representation of a timestamp.

### Fields inherited from class org.h2.value.Value

`ARRAY, BLOB, BOOLEAN, BYTE, BYTES, CLOB, DATE, DECIMAL, DOUBLE, ENUM, FLOAT, GEOMETRY, INT, INTERVAL_DAY, INTERVAL_DAY_TO_HOUR, INTERVAL_DAY_TO_MINUTE, INTERVAL_DAY_TO_SECOND, INTERVAL_HOUR, INTERVAL_HOUR_TO_MINUTE, INTERVAL_HOUR_TO_SECOND, INTERVAL_MINUTE, INTERVAL_MINUTE_TO_SECOND, INTERVAL_MONTH, INTERVAL_SECOND, INTERVAL_YEAR, INTERVAL_YEAR_TO_MONTH, JAVA_OBJECT, LONG, MIN_LONG_DECIMAL, NULL, RESULT_SET, ROW, SHORT, STRING, STRING_FIXED, STRING_IGNORECASE, TIME, TIMESTAMP, TIMESTAMP_TZ, TYPE_COUNT, UNKNOWN, UUID`

### Fields inherited from class org.h2.value.VersionedValue

`DUMMY`

### Method Summary

Methods
`Value` `add(Value v)` Add a value and return the result.
`boolean` `checkPrecision(long precision)` Check if the precision is smaller or equal than the given precision.
`int` `compareTypeSafe(Value o, CompareMode mode)` Compare this value against another value given that the values are of the same data type.
`Value` `convertScale(boolean onlyToSmallerScale, int targetScale)` Convert the scale.
`boolean` `equals(java.lang.Object other)` Check if the two values have the same hash code.
`static ValueTimestampTimeZone` `fromDateValueAndNanos(long dateValue, long timeNanos, short timeZoneOffsetMins)` Get or create a date value for the given date.
`static ValueTimestampTimeZone` `get(TimestampWithTimeZone timestamp)` Get or create a timestamp value for the given timestamp.
`long` `getDateValue()` A bit field with bits for the year, month, and day (see DateTimeUtils for encoding).
`int` `getMemory()` Get the memory used by this object.
`java.lang.Object` `getObject()` Get the value as an object.
`java.lang.StringBuilder` `getSQL(java.lang.StringBuilder builder)` Appends the SQL expression for this value to the specified builder.
`java.lang.String` `getString()` Get the value as a string.
`long` `getTimeNanos()` The nanoseconds since midnight.
`java.sql.Timestamp` `getTimestamp()`
`short` `getTimeZoneOffsetMins()` The timezone offset in minutes.
`TypeInfo` `getType()` Returns the data type.
`int` `getValueType()` Get the value type.
`int` `hashCode()`
`static ValueTimestampTimeZone` `parse(java.lang.String s)` Parse a string to a ValueTimestamp.
`void` `set(java.sql.PreparedStatement prep, int parameterIndex)` Set the value as a parameter in a prepared statement.
`Value` `subtract(Value v)` Subtract a value and return the result.

### Methods inherited from class org.h2.value.Value

`clearCache, compareTo, compareWithNull, containsNull, convertPrecision, convertTo, convertTo, convertTo, convertTo, convertToInt, copy, copyToResult, copyToTemp, divide, getBigDecimal, getBoolean, getByte, getBytes, getBytesNoCopy, getDataHandler, getDate, getDouble, getFloat, getHigherOrder, getHigherType, getInputStream, getInputStream, getInt, getLong, getReader, getReader, getResult, getShort, getSignum, getSmall, getSQL, getTableId, getTime, getTraceSQL, getUnsupportedExceptionForOperation, isLinkedToTable, modulus, multiply, negate, remove, toString`

### Methods inherited from class org.h2.value.VersionedValue

`getCommittedValue, getCurrentValue, getOperationId, isCommitted`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Field Detail

#### DEFAULT_PRECISION

    public static final int DEFAULT_PRECISION

The default precision and display size of the textual representation of a timestamp. Example: 2001-01-01 23:59:59.123456+10:00

See Also:
  Constant Field Values

#### MAXIMUM_PRECISION

    public static final int MAXIMUM_PRECISION

The maximum precision and display size of the textual representation of a timestamp. Example: 2001-01-01 23:59:59.123456789+10:00

See Also:
  Constant Field Values

### Method Detail

#### fromDateValueAndNanos

    public static ValueTimestampTimeZone fromDateValueAndNanos(long dateValue,
                                               long timeNanos,
                                               short timeZoneOffsetMins)

Get or create a date value for the given date.

Parameters:
  `dateValue` - the date value, a bit field with bits for the year, month, and day
  `timeNanos` - the nanoseconds since midnight
  `timeZoneOffsetMins` - the timezone offset in minutes
Returns:
  the value

#### get

    public static ValueTimestampTimeZone get(TimestampWithTimeZone timestamp)

Get or create a timestamp value for the given timestamp.

Parameters:
  `timestamp` - the timestamp
Returns:
  the value

#### parse

    public static ValueTimestampTimeZone parse(java.lang.String s)

Parse a string to a ValueTimestamp. This method supports the format +/-year-month-day hour:minute:seconds.fractional and an optional timezone part.

Parameters:
  `s` - the string to parse
Returns:
  the date

#### getDateValue

    public long getDateValue()

A bit field with bits for the year, month, and day (see DateTimeUtils for encoding).

Returns:
  the data value

#### getTimeNanos

    public long getTimeNanos()

The nanoseconds since midnight.

Returns:
  the nanoseconds

#### getTimeZoneOffsetMins

    public short getTimeZoneOffsetMins()

The timezone offset in minutes.

Returns:
  the offset

#### getTimestamp

    public java.sql.Timestamp getTimestamp()

Overrides:
  `getTimestamp` in class `Value`

#### getType

    public TypeInfo getType()

Description copied from class: `Value`
Returns the data type.

Specified by:
  `getType` in class `Value`
Returns:
  the data type

#### getValueType

    public int getValueType()

Description copied from class: `Value`
Get the value type.

Specified by:
  `getValueType` in class `Value`
Returns:
  the value type

#### getMemory

    public int getMemory()

Description copied from class: `Value`
Get the memory used by this object.

Overrides:
  `getMemory` in class `Value`
Returns:
  the memory used in bytes

#### getString

    public java.lang.String getString()

Description copied from class: `Value`
Get the value as a string.

Specified by:
  `getString` in class `Value`
Returns:
  the string

#### getSQL

    public java.lang.StringBuilder getSQL(java.lang.StringBuilder builder)

Description copied from class: `Value`
Appends the SQL expression for this value to the specified builder.

Specified by:
  `getSQL` in class `Value`
Parameters:
  `builder` - string builder
Returns:
  the specified string builder

#### checkPrecision

    public boolean checkPrecision(long precision)

Description copied from class: `Value`
Check if the precision is smaller or equal than the given precision.

Overrides:
  `checkPrecision` in class `Value`
Parameters:
  `precision` - the maximum precision
Returns:
  true if the precision of this value is smaller or equal to the given precision

#### convertScale

    public Value convertScale(boolean onlyToSmallerScale,
                     int targetScale)

Description copied from class: `Value`
Convert the scale.

Overrides:
  `convertScale` in class `Value`
Parameters:
  `onlyToSmallerScale` - if the scale should not reduced
  `targetScale` - the requested scale
Returns:
  the value

#### compareTypeSafe

    public int compareTypeSafe(Value o,
                      CompareMode mode)

Description copied from class: `Value`
Compare this value against another value given that the values are of the same data type.

Specified by:
  `compareTypeSafe` in class `Value`
Parameters:
  `o` - the other value
  `mode` - the compare mode
Returns:
  0 if both values are equal, -1 if the other value is smaller, and 1 otherwise

#### equals

    public boolean equals(java.lang.Object other)

Description copied from class: `Value`
Check if the two values have the same hash code. No data conversion is made; this method returns false if the other object is not of the same class. For some values, compareTo may return 0 even if equals return false. Example: ValueDecimal 0.0 and 0.00.

Specified by:
  `equals` in class `Value`
Parameters:
  `other` - the other value
Returns:
  true if they are equal

#### hashCode

    public int hashCode()

Specified by:
  `hashCode` in class `Value`

#### getObject

    public java.lang.Object getObject()

Description copied from class: `Value`
Get the value as an object.

Specified by:
  `getObject` in class `Value`
Returns:
  the object

#### set

    public void set(java.sql.PreparedStatement prep,
           int parameterIndex)
             throws java.sql.SQLException

Description copied from class: `Value`
Set the value as a parameter in a prepared statement.

Specified by:
  `set` in class `Value`
Parameters:
  `prep` - the prepared statement
  `parameterIndex` - the parameter index
Throws:
  `java.sql.SQLException`

#### add

    public Value add(Value v)

Description copied from class: `Value`
Add a value and return the result.

Overrides:
  `add` in class `Value`
Parameters:
  `v` - the value to add
Returns:
  the result

#### subtract

    public Value subtract(Value v)

Description copied from class: `Value`
Subtract a value and return the result.

Overrides:
  `subtract` in class `Value`
Parameters:
  `v` - the value to subtract
Returns:
  the result